#lang imperative-syndicate

(provide server-facet/tcp
         default-tcp-server-port
         spawn-tcp-server!)

(require "../wire-protocol.rkt")

(require/activate imperative-syndicate/drivers/tcp)
(require/activate imperative-syndicate/distributed/server)

(define (server-facet/tcp id scope)
  (assert (tcp-accepted id))
  (assert (server-poa id scope))
  (define accumulate! (packet-accumulator (lambda (p) (send! (message-poa->server id p)))))
  (on (message (tcp-in id $bs))
      (accumulate! bs))
  (on (message (message-server->poa id $p))
      (send! (tcp-out id (encode p)))))

(define default-tcp-server-port 8001)

(define (spawn-tcp-server! [port default-tcp-server-port])
  (spawn #:name 'tcp-server-listener
         (define tcp-scope "broker") ;; TODO: allow this to be negotiated during protocol startup
         (during/spawn (tcp-connection $id (tcp-listener port))
           #:name `(server-poa ,tcp-scope ,id)
           (server-facet/tcp id tcp-scope))))
